#include <stdio.h>
#include <stdlib.h>
#include "hmm.h"

/*   д Լ  */
void read_data(int[], char*);
/*  ͺ ˰ Ű Լ  */
void viterbi();

Fair fair_die = 
{.95l, .05l, {.0l, 1.0l/6.0l, 1.0l/6.0l, 1.0l/6.0l, 1.0l/6.0l, 1.0l/6.0l, 1.0l/6.0l}};

Loaded loaded_die = 
{.9l, .1l, {.0l, 1.0l/10.0l, 1.0l/10.0l, 1.0l/10.0l, 1.0l/10.0l, 1.0l/10.0l, 1.0l/2.0l}};

/* Լ  */
int main(int argc, char *argv[])
{
    read_data(result, which_dice);
    viterbi();
    system("PAUSE");	
    return 0;
}

void read_data(int result[], char* which_idce){
    FILE* fp = NULL;
    char ch;
    unsigned int line_num = 0;
    unsigned int result_count = 0;
    unsigned int which_dice_count = 0;
    
    /* ־   ġ   о̱ ؼ */
    fp = fopen("1802_TEST.txt", "r");
    while((ch = getc(fp)) != EOF){
        if(ch == '\n'){ 
            line_num++;
            continue;
        }
        if(line_num == 0 || line_num == 6) continue;
        if(line_num >= 1 && line_num <= 5){/* ֻ   оδ. */
            result[result_count++] = atoi(&ch);
        }
        if(line_num >= 7 && line_num <= 11){/* ־  ͸ оδ. */
            *(which_dice+(which_dice_count++)) = ch;
        }
    } 
    fclose(fp);
}


void viterbi(){
    long double delta_prev[2]; /* (load , fair) */
    long double delta_now[2];
    long double max_value;
    int t; /* ð Ÿ */
    int back_track_t, count;
    long double best_score;
    int index_of_end_back = -1;
    char induct_result[NUM_OF_RESULT+1];
    induct_result[NUM_OF_RESULT] = '\0';
    
    /* initialization  */
    delta_now[0] = pi_load * loaded_die.face[result[0]];
    delta_now[1] = pi_fair * fair_die.face[result[0]];
    back_track[0][0] = 'S'; /* ƮŷҶ  Ÿ */
    back_track[0][1] = 'S';
    /* initialization  */
    
    /* Induction  */
    for(t=1;t < NUM_OF_RESULT;t++){
        delta_prev[0] = delta_now[0];
        delta_prev[1] = delta_now[1];

        /* Load state   */
        max_value = delta_prev[0] * loaded_die.transition_to_self;
        back_track[t][0] = 'L';
        if( max_value < (delta_prev[1] * fair_die.transition_to_loaded)){
            max_value = delta_prev[1] * fair_die.transition_to_loaded;
            back_track[t][0] = 'F';
        }
        delta_now[0] = max_value * loaded_die.face[result[t]];
        
        /* Fair State   */
        max_value = delta_prev[0] * loaded_die.transition_to_fair;
        back_track[t][1] = 'L';
        if( max_value < (delta_prev[1] * fair_die.transition_to_self)){
            max_value = delta_prev[1] * fair_die.transition_to_self;
            back_track[t][1] = 'F';
        }
        delta_now[1] = max_value * fair_die.face[result[t]];
    }
    /* Induction  */
    
    /* Termination  */
    if(delta_now[0] < delta_now[1]){
        best_score = delta_now[1];
        index_of_end_back = 1;
        induct_result[299] = 'F';
    }else if(delta_now[0] > delta_now[1]){
        best_score = delta_now[0];
        index_of_end_back = 0;
        induct_result[299] = 'L';
    }
    /* Termination  */
    
    /* Back Tracking  */
    for(back_track_t = NUM_OF_RESULT-2 ; back_track_t >= 0 ; back_track_t--){
        
        induct_result[back_track_t] = back_track[back_track_t+1][index_of_end_back];
        
        if(induct_result[back_track_t] == 'L'){
            index_of_end_back = 0;
        }else if(induct_result[back_track_t] == 'F'){
            index_of_end_back = 1;
        }
        
    }
    /* Back Tracking  */
    
    /*   */
    printf("Given Result!\n%s\n\n", which_dice);
    printf("Viterbi Result!\n%s\n\n", induct_result);
    count = 0;
    for(t = 0; t < NUM_OF_RESULT;t++){
        if(induct_result[t] != which_dice[t]){
            count++;
        }
    }
    printf("Error rate %f %%\n", (((float)count/(float)NUM_OF_RESULT)*100));
    
}

